% TTR Lab session -29/03/2017- EIGENFACES - Marco Cristani 
clear all;
close all;
% -------------------------------------------------------------
% Eigenfaces
% -------------------------------------------------------------

dire    =    '.\images'; % ORL face database (plus my images!!!)
list    =   dir(strcat(dire,'\*.bmp'));
M       =   size(list,1);
tmp     =   imread(strcat(dire,'\',list(1).name));
[r,c]   =   size(tmp);
TMP     =   zeros(r*c,M);
figure;
for i=1:M
    tmp = imread(strcat(dire,'\',list(i).name));
        imagesc(tmp); axis image; colormap gray;
        drawnow;
        pause(0.01);
        TMP(:,i)= tmp(:);
        mont(:,:,1,i)= tmp;
end
figure;
montage(mont);
set(gcf,'name','Gallery');

TMP                     =   double(TMP);
media                   =   mean(TMP,2);
A(:,:)                  =   TMP-repmat(media,1,M);

figure;
set(cgf,'name','mean face');
mimage = reshape(media,r,c);
imagesc(mimage);
colormap gray, axis image;
[U,lambda]              =   eigen_training(A);

%Exercize 1
% write the eigen_training function, which takes the mean-subtracted matrix
% of faces, and apply the eigenfaces algorithm. Remember, the algorithm is
% the same as PCA, but instead of the scatter matrix (AA') we have that
% projection in M-dimensions A'A. U should contain the ordered
% eigenvectors, lambda the corresponding eigenvalues.

% Exercize 2 
% show the eigenvectors in a figure as they were images (in fact we are talking)
% about "eigenfaces". For convenience, show just the first 25 eigefaces

% Visualizing the first 25 eigenfaces
figure;
for i=1:25
    subplot(5,5,i); imagesc(reshape(U(:,i),[r,c]));
    colormap gray; axis image; axis off; title(num2str(i)); colorbar
end

% Exercize 3 
% show the eigenvectors that are far in the ordering (for example, starting from the 300th). 
% For convenience, show just 25 eigefaces
figure;
for i=1:25
    subplot(5,5,i); imagesc(reshape(U(:,i+300),[r,c]));
    colormap gray; axis image; axis off; title(num2str(i+300)); colorbar
end
% Exercize 4 
% show the eigenvalues and the amount of cumulative variance they capture

figure;
subplot(211)
plot(lambda); title('Eigenvalues');
hold on;
scatter([1:M],lambda);

subplot(212)
y = cumsum(lambda)/sum(lambda);
plot(y); title('Modelled Information')
hold on;
scatter([1:M],y);

%Exercize 5 Do 2D projection of faces! Show the projected faces on a two
%dimensional space.

% % % 2D
T           =   2;
omega       =   U(:,1:T)'*A; % proiezione;
figure; set(gcf,'name','Visualizzazione 2D dei volti');
scatter(omega(1,:),omega(2,:));
l           =   reshape(repmat([1:40],10,1),400,1);
for i=1:M
    text(omega(1,i)+25,omega(2,i)+25,num2str(l(i)))
end
% 
% for i=1:M
%     text(omega(1,i)+25,omega(2,i)+25,num2str(i))
% end

% exercize 6
% I'm considering that you have your personal data in the dataset, so 10
% images. You need to compute, for each of these 10 images the distances
% wrt all the other images in the low/dimensional space, for example using
% a number of eigenvectors that model 90% of the variance.

% Then, for each of the image, you can compute the subject which is the
% closest one. For each of the 10 images you will have a subject which is
% the closest one

% In order to select just the most similar one, you need to evaluate a
% majority criterion over the 10 most similar subjects you had.



% Exercize 7
% In the cloud of points in my few-dimensional space (400 or 410), I want to compute the
% maximum distance and the minimum distance holding between the w
% projections. Visualize the pair of images corresponding to the minimum
% and maximum distance.
T           =   399;
omega       =   U(:,1:T)'*A; % my projection;
for i=1:M
    for j=1:M
        dista(i,j)= norm(omega(:,i)'-omega(:,j)');
    end
end
figure; imagesc(dista); set(gcf,'name','Distances among projections')
colorbar;
dista = dista + diag(ones(1,M)*inf);
[distmin,Imin]= min(dista(:));
[sim_i,sim_j]=ind2sub([M,M],Imin);
[distmax,Imax]= max(dista(dista~=inf));
[dsim_i,dsim_j]=ind2sub([M,M],Imax);
figure; set(gcf,'name','Similarita nello spazio 50D = spazio orig?');
subplot(2,2,1); imagesc(reshape(TMP(:,sim_i),r,c));axis image
title(strcat(num2str(sim_i),'-simile-')); colormap gray
subplot(2,2,2); imagesc(reshape(TMP(:,sim_j),r,c));axis image
title(strcat(num2str(sim_j),'-simile-')); colormap gray
subplot(2,2,3); imagesc(reshape(TMP(:,dsim_i),r,c));axis image
title(strcat(num2str(dsim_i),'-dissimile-')); colormap gray
subplot(2,2,4); imagesc(reshape(TMP(:,dsim_j),r,c));axis image
title(strcat(num2str(dsim_j),'-dissimile-')); colormap gray

% Exercize 8
% Reconstruction. Given a particular image, which has been projected in my
% M-dimensional space, I want to reconstruct it by using the formula x = m+
% \sum_{k=1...M}a_k e_k. Do a loop in Matlab, showing how the partial
% reconstruction (til the k' component < M) are looking like.




%% Effettuare prove di ricostruzione, al variare del numero di eigenfaces
hhh=figure; 
rec = [];
rico = 123;
omega = [];
for t=1:399
    T              =   t;
    omegatmp       =   U(:,T)'*A(:,rico); % proiezione;
    omega          =   [omega; omegatmp];
    
    rec = media + U(:,1:T)*omega;
    subplot(1,3,1); imagesc(reshape(TMP(:,rico),r,c)); colormap gray
    title('originale'); axis image
     subplot(1,3,2); imagesc(reshape(rec,r,c)); colormap gray
    title(strcat('ricostruita con ',num2str(t),'-autovettori')); axis image
    subplot(1,3,3); imagesc(reshape(U(:,t),r,c)); colormap gray
    title(strcat('eigenface n:',num2str(t),'|a_i=',num2str(omega(t)))); axis image
    drawnow; pause (1); 
    mov(t) = getframe(hhh)
end


% Exercize 9
% Reconstruct an image of your dataset that has -NOT- used to build the
% eigenspace. How is its reconstruction, in terms of similarity with the
% original image?

clear U
clear lambda
clear A
ind_img                 =   110; % this is the image I want to keep out;
% good                    =   setdiff([1:M], ind_img); % subtracting it from the original dataset
TMPnew                  =   TMP;
TMPnew(:,ind_img)       =   []; %obtaining a different dataset with my image which is absent here
media                   =   mean(TMPnew,2);
A(:,:)                  =   TMPnew-repmat(media,1,M-1);
[U,lambda]              =   eigen_training(A);

omega = [];
for t=1:400
    T              =   t;
    omegatmp       =   U(:,T)'*(TMP(:,ind_img)-media); % proiezione;
    omega          =   [omega; omegatmp];
    rec = media + U(:,1:T)*omega;
    subplot(1,3,1); imagesc(reshape(TMP(:,ind_img),r,c)); colormap gray
    title('originale'); axis image
     subplot(1,3,2); imagesc(reshape(rec,r,c)); colormap gray
    title(strcat('ricostruita con ',num2str(t),'-autovettori')); axis image
    subplot(1,3,3); imagesc(reshape(U(:,t),r,c)); colormap gray
    title(strcat('eigenface n:',num2str(t),'|a_i=',num2str(omega(t)))); axis image
    drawnow; pause (0.01); 
end

 % Exercize 10
% Reconstruct an image of subject i by using an eigenspace whose eigenvectors have been
% created -WITHOUT ANY OF THE IMAGES OF SUBJECT i- and check the quality of the reconstruction 

clear U
clear lambda
clear A
ind_img                 =   101:110; % this is the image I want to keep out;
% good                    =   setdiff([1:M], ind_img); % subtracting it from the original dataset
TMPnew                  =   TMP;
TMPnew(:,ind_img)       =   []; %obtaining a different dataset with my image which is absent here
media                   =   mean(TMPnew,2);
A(:,:)                  =   TMPnew-repmat(media,1,M-10);
[U,lambda]              =   eigen_training(A);

omega = [];
rico= 110;
for t=1:390
    T              =   t;
    omegatmp       =   U(:,T)'*(TMP(:,rico)-media); % proiezione;
    omega          =   [omega; omegatmp];
    rec = media + U(:,1:T)*omega;
    subplot(1,3,1); imagesc(reshape(TMP(:,rico),r,c)); colormap gray
    title('originale'); axis image
     subplot(1,3,2); imagesc(reshape(rec,r,c)); colormap gray
    title(strcat('ricostruita con ',num2str(t),'-autovettori')); axis image
    subplot(1,3,3); imagesc(reshape(U(:,t),r,c)); colormap gray
    title(strcat('eigenface n:',num2str(t),'|a_i=',num2str(omega(t)))); axis image
    drawnow; pause (0.01); 
 end

 % THE VERY LAST EXERCIZE!!!
 % MAD!!!
 % Reconstruct an image of WHATEVER YOU WANT (please, not a face!) with
 % your eigenspace. Evaluate the reconstruction. This is an example of
 % HALLUCINATION.
 
 
 omega = [];
rico= 110;
mad  = double(imresize(rgb2gray(imread('shoes.jpg')),[112,92]));
for t=1:390
    T              =   t;
    omegatmp       =   U(:,T)'*(mad(:)-media); % proiezione;
    omega          =   [omega; omegatmp];
    rec = media + U(:,1:T)*omega;
    subplot(1,3,1); imagesc(mad); colormap gray
    title('originale'); axis image
     subplot(1,3,2); imagesc(reshape(rec,r,c)); colormap gray
    title(strcat('ricostruita con ',num2str(t),'-autovettori')); axis image
    subplot(1,3,3); imagesc(reshape(U(:,t),r,c)); colormap gray
    title(strcat('eigenface n:',num2str(t),'|a_i=',num2str(omega(t)))); axis image
    drawnow; pause (0.01); 
end
 

% Exercize 11 Face recognition by eigenfaces
% Design a recognition system which does the following things:
% 1) It takes a gallery set of identities (The 41 identities that we have, 10 images for each identity)
% 2) It pulls out from these identities a single image (for each identity)
% that will be used as test image afterwards
% 3) It learns eigenfaces with the remaining "gallery" images (9 per identity), and projects the gallery in the few dimensional
% space
% 4) For each test or "probe" image, apply the eigenface recognition algorithm
% 5) Evaluate the overall accuracy
% 6) Repeat the previous steps, by changing the test image, 10 times in
% total

% Note: for classifying an image, use the KNN algorithm, with a number of
% neighbors at your choice

clear all
close all

dire    =    '.\images'; % ORL face database
list    =   dir(strcat(dire,'\*.bmp'));
M       =   size(list,1);
tmp     =   imread(strcat(dire,'\',list(1).name));
[r,c]   =   size(tmp);
TMP     =   zeros(r*c,M);
figure;
for i=1:M
    tmp = imread(strcat(dire,'\',list(i).name));
    TMP(:,i)= tmp(:);
end
TMP                     =   double(TMP);
hrec   = figure; set(gcf,'name','FACE RECOGNITION');
label  = reshape(repmat([1:40],10,1),400,1);
% conf = zeros(40,40);
num_instances = 10;
num_identities = 40;
num_iter = num_instances;
test_i = 0;
for iter = 1:num_instances
    probe_i = iter:num_instances:M;
    probe = TMP(:,probe_i);
    newTMP = TMP;
    newTMP(:,probe_i) = [];
    newlabel = label;
    newlabel(probe_i) = [];
    media                   =   mean(newTMP,2);
    newA                    =   newTMP-repmat(media,1,size(newTMP,2));
    [U,lambda]              =   eigen_training(newA);
    % Deciding the number of components to be taken
    T           =   M-num_identities;
    omega_g       =   U(:,1:T)'*newA; % projection of the gallery;
    omega_p     =   U(:,1:T)'*(probe-repmat(media,1,num_identities)); % projection of the probe
    num_neigh = 5;
    for j = 1:num_identities
        test_i = test_i + 1;
        class = knnclassify(omega_p(:,j)',omega_g',newlabel,num_neigh);
        subplot(211); imagesc(reshape(TMP(:,probe_i(j)),r,c)); title('probe');...
        colormap gray, axis image;
        figure(hrec); subplot(212); imagesc(reshape(TMP(:,class*10-1),r,c));colormap gray, axis image;
        accuracy(test_i)=class==j;
        title(strcat('matched?:',num2str(accuracy(test_i))))
        fprintf('run %i|%i: accuracy = %i\n',test_i,M,accuracy(test_i));
       drawnow
    pause(0.02);  
    end
end
sum(accuracy)/400



% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% 
% 
% 
% 
% % %%Annullamento di una componente: cosa accade?
% %     if t==4
% %         omegatmp = -omegatmp;
% %     end
% % 
% % 
% % 
% % 
% % 
% % 
% %% Analisi delle singole basi
% 
% figure;
% for i=1:25
%     subplot(5,5,i); imagesc(reshape(U(:,i),[r,c]));
%     colormap gray; axis image; axis off;
% %     title(num2str(lambda(i),'%0.5g'));
%     title(lambda(i));
% end
% 
% 
% Tan           =   [1]; %base analizzata
% omega       =   U(:,Tan)'*A; % proiezione su un'unica base;
% 
% 
% [thrash, ind] = sort(omega,'ascend');
% 
% figure; set(gcf,'name','Analisi singole basi');
% conta = 0;
% 
% for i=1:1:25
%     conta =conta +1;
% subplot(5,5,conta); 
% imagesc(reshape(TMP(:,ind(i)),r,c));axis image; 
% title(num2str(ind(i)))
% end
% colormap gray
% 
% 
% 
% 
% %% Prove di analisi di robustezza della ricostruzione
% 
% 
% 
% % Aggiungo ad un'immagine del rumore impulsivo
% clear U
% clear lambda
% clear A
% ind_img               =   110
% good                    =   setdiff([1:M], ind_img);
% TMPnew                  =   TMP;
% TMPnew(:,ind_img)     =   [];
% media                   =   mean(TMPnew,2);
% A(:,:)                  =   TMPnew-repmat(media,1,M-1);
% 
% [U,lambda]              =   eigen_training(A);
% 
% img_noise = TMP(:,ind_img);
% figure; set(gcf,'name','Prove di robustezza al rumore')
% subplot(131)
% imagesc(reshape(img_noise,r,c)); axis image; colormap gray; axis off
% title('img originale')
% img_noise = imnoise(uint8(img_noise),'salt & pepper', 0.02);
% subplot(132)
% imagesc(reshape(img_noise,r,c)); axis image; colormap gray; axis off
% title('img con noise')
% 
% omega_noise = U'*(double(img_noise)-media);
% rec = media + U*omega_noise;
% subplot(133)
% imagesc(reshape(rec,r,c)); axis image; colormap gray; axis off
% title('ricostruzione');
% 
% omega       =   U'*A; % per avere le proiezioni della dimensionalita'
%                       %  di partenza
% distanza_orig = norm(omega_noise - omega(:,100))
% 
% % %Prova di occlusione;
% % img_occ = TMP(:,80);
% % figure; set(gcf,'name','Prove di robustezza ad occlusione')
% % subplot(131)
% % imagesc(reshape(img_occ,r,c)); axis image; colormap gray; 
% % title('img originale')
% % 
% % img_occ = reshape(img_occ,r,c);
% % img_occ(50:70,20:40)=10;
% % img_occ(50:70,55:75)=10;
% % subplot(132)
% % imagesc(reshape(img_occ,r,c)); axis image; colormap gray; 
% % title('img occlusa');
% % 
% % omega_occ = U'*(double(img_occ(:))-media);
% % rec = media + U*omega_occ;
% % subplot(133)
% % imagesc(reshape(rec,r,c)); axis image; colormap gray; axis off
% % title('ricostruzione');
% % 
% % 
% % % Prendere un'immagine e proiettarla su 2D con PCA, 
% % % ottenendo w. Aggiungere del rumore all'immagine, 
% % % proiettarla, ottenendo w2. Come sono relazionati tra di 
% % % loro w e w2 in termini di distanza?
% % 
% % ind_img   =   110
% % img_noise = TMP(:,ind_img);
% % figure; set(gcf,'name','Prove di robustezza al rumore')
% % subplot(131)
% % imagesc(reshape(img_noise,r,c)); axis image; colormap gray; axis off
% % title('img originale')
% % img_noise = imnoise(uint8(img_noise),'salt & pepper', 0.02);
% % subplot(132)
% % imagesc(reshape(img_noise,r,c)); axis image; colormap gray; axis off
% % title('img con noise')
% % 
% % img_occ = TMP(:,ind_img)
% % img_occ = reshape(img_occ,r,c);
% % img_occ(50:70,20:40)=10;
% % img_occ(50:70,55:75)=10;
% % 
% % subplot(133)
% % imagesc(reshape(img_occ,r,c)); axis image; colormap gray; 
% % title('img occlusa');
% % 
% % omega = U'*(double(TMP(:,ind_img))-media);
% % omega_noise = U'*(double(img_noise)-media);
% % omegaall =  U'*A;
% % 
% % figure; set(gcf,'name','Visualizzazione 2D dei volti');
% % scatter(omegaall(1,:),omegaall(2,:));hold on
% % scatter(omega(1,:),omega(2,:),'r');
% % scatter(omega_noise(1,:),omega_noise(2,:),'k');
% % omega_occ = U'*(double(img_occ(:))-media);
% % scatter(omega_occ(1,:),omega_occ(2,:),'g');

% %% RICOSTRUZIONE
% % Estrazione probe (elemento incognito)
% num_tolti =10;
% index_class= round(unifrnd(1,40)); %indice probe sulla classe
% probe = TMP(:,index_class*10-num_tolti+1:index_class*10);
% hrec = figure; set(gcf,'name','RICOSTRUZIONE VOLTI');
% for i=1:num_tolti
% subplot(2,num_tolti,i); imagesc(reshape(probe(:,i),r,c)); title('probe');colormap gray, axis image;
% end
% newTMP = [TMP(:,1:index_class*10-num_tolti),TMP(:,index_class*10+1:end)]; %prob se probe e' l'ultimo elto;
% % Creazione eigenvalues
% media                   =   mean(newTMP,2);
% newA                    =   newTMP-repmat(media,1,M-num_tolti);
% [U,lambda]              =   eigen_training(newA);
% % Proiezione incognito, decido il numero di compo.
% T           =   300;
% omega_p     =   U(:,1:T)'*(probe-repmat(media,1,num_tolti));
% recon       =   U(:,1:T)*omega_p +repmat(media,1,num_tolti);
% for i=1:num_tolti
% subplot(2,num_tolti,i+num_tolti); imagesc(reshape(recon(:,i),r,c)); title('rec ');colormap gray, axis image;
% end